<?php
if (!defined("CLUEVO_ACTIVE")) exit;

function cluevo_get_the_lms_tree() {
  global $cluevo_tree;
  return $cluevo_tree;
}

function cluevo_get_the_lms_user() {
  global $cluevo;
  return $cluevo->user;
}

function cluevo_get_the_lms_user_level() {
  $user = cluevo_get_the_lms_user();

  return $user->level["current"];
}

function cluevo_get_the_lms_user_exp() {
  $user = cluevo_get_the_lms_user();

  return $user->level['exp'];
}

function cluevo_get_the_lms_user_exp_next() {
  $user = cluevo_get_the_lms_user();

  return $user->level['next'];
}

function cluevo_get_the_lms_user_exp_remaining() {
  $user = cluevo_get_the_lms_user();

  return $user->level['remaining'];
}

function cluevo_get_the_lms_user_exp_pct() {
  $user = cluevo_get_the_lms_user();

  return $user->level['pct'];
}

function cluevo_get_the_lms_user_title() {
  $user = get_the_lms_user();

  return $user->level['title'];
}

function cluevo_the_lms_user_level() {
  $user = cluevo_get_the_lms_user();

  echo esc_html($user->level['current']);
}

function cluevo_the_lms_user_exp() {
  $user = cluevo_get_the_lms_user();

  echo esc_html($user->level['exp']);
}

function cluevo_the_lms_user_exp_next() {
  $user = cluevo_get_the_lms_user();

  echo esc_html($user->level['next']);
}

function cluevo_the_lms_user_exp_remaining() {
  $user = cluevo_get_the_lms_user();

  echo esc_html($user->level['remaining']);
}

function cluevo_the_lms_user_exp_pct() {
  $user = cluevo_get_the_lms_user();

  echo esc_html($user->level['pct']);
}

function cluevo_the_lms_user_title() {
  $user = cluevo_get_the_lms_user();

  echo esc_html($user->level['title']);
}

function cluevo_has_lms_user_title() {
  $user = cluevo_get_the_lms_user();
  return !empty($user->level['title']);
}

function cluevo_have_lms_items() {
  global $cluevo;
  if (!empty($cluevo)) {
    return $cluevo->have_items();
  } else {
    return false;
  }
}

function cluevo_have_visible_lms_items() {
  global $cluevo;
  if (!empty($cluevo)) {
    return $cluevo->have_visible_items();
  } else {
    return false;
  }
}

function cluevo_the_lms_item_is_visible() {
  global $cluevo;
  if (!empty($cluevo) && !empty($cluevo->item)) {
    return ($cluevo->item->access || $cluevo->item->access_status["access_level"] > 0);
  } else {
    return false;
  }
}

function cluevo_the_lms_item($intId = null) {
  global $cluevo;
  return $cluevo->the_item();
}

function cluevo_get_the_lms_item_title() {
  global $cluevo;
  return $cluevo->item['metadata']->post_title;
}

function cluevo_the_lms_item_title() {
  echo esc_html(cluevo_get_the_lms_item_title());
}

function cluevo_the_lms_item_metadata() {
  global $cluevo;
  return $cluevo->the_item_metadata();
}

function cluevo_get_the_lms_item_type() {
  global $cluevo;
  return $cluevo->the_item_type();
}

function cluevo_the_lms_item_type() {
  global $cluevo;
  echo esc_attr($cluevo->the_item_type());
}

function cluevo_the_lms_tree() {
  global $cluevo;
  return $cluevo->tree;
}

function cluevo_have_lms_modules() {
  global $cluevo;
  return $cluevo->have_modules();
}

function cluevo_the_lms_module() {
  global $cluevo;
  return $cluevo->the_module();
}

function cluevo_the_lms_module_metadata() {
  global $cluevo;
  return $cluevo->the_module_metadata();
}

function cluevo_get_the_lms_module_progress() {
  global $cluevo;
  return $cluevo->the_module_progress();
}

function cluevo_the_lms_module_progress() {
  global $cluevo;
  echo esc_attr($cluevo->the_module_progress());
}

function cluevo_the_lms_module_progress_pct() {
  global $cluevo;
  echo esc_html($cluevo->the_module_progress() * 100 . "%");
}

function cluevo_the_lms_item_string_path() {
  global $cluevo;
  if (cluevo_in_the_lms_dependency_loop())
    return implode(' / ', $cluevo->dependency['path']['string']);
  else
    return implode(' / ', $cluevo->item['path']['string']);
}

function cluevo_the_lms_item_title_path() {
  global $cluevo;
  $ids = [];
  if (cluevo_in_the_lms_dependency_loop())
    $ids = $cluevo->dependency['path']['id'];
  else
    $ids = $cluevo->item['path']['id'];

  $parts = [];
  foreach ($ids as $id) {
    $parts[] = $cluevo->tree[$id]['metadata']->post_title;
  }

  return implode(' / ', $parts);

}

function cluevo_in_the_lms_dependency_loop() {
  global $cluevo;
  return $cluevo->in_the_dependency_loop;
}

function cluevo_get_the_lms_page() {
  global $cluevo;
  if (!empty($cluevo)) {
    return $cluevo->current_page;
  }
}

function cluevo_get_the_parent_lms_page() {
  global $cluevo;
  if (!empty($cluevo)) {
    if ($cluevo->shortcode)
      return false;

    if (!empty($cluevo->current_page->parent_id)) {
      $userId = (!empty($cluevo->user) && !empty($cluevo->user->ID)) ? $cluevo->user->ID : null;
      $metadataId = cluevo_get_metadata_id_from_item_id($cluevo->current_page->parent_id);
      if ($metadataId) {
        return get_post($metadataId);
      }
    } else {
      return get_page_by_title( 'Index', OBJECT, CLUEVO_PAGE_POST_TYPE);
    }
  }

  return null;
}

function cluevo_get_the_lms_item() {
  global $cluevo;
  if ($cluevo->in_the_dependency_loop)
    return $cluevo->dependency;
  else
    return $cluevo->item;
}

function cluevo_get_the_next_lms_item() {
  global $wpdb, $cluevo;
  $table = $wpdb->prefix . CLUEVO_DB_TABLE_TREE;
  $sql = "SELECT item_id FROM $table WHERE parent_id = %d AND sort_order > %d ORDER BY sort_order ASC LIMIT 1";
  $result = $wpdb->get_var(
    $wpdb->prepare($sql, [ $cluevo->current_page->parent_id, $cluevo->current_page->sort_order ] )
  );

  if (!empty($result)) {
    return cluevo_get_learning_structure_item($result, get_current_user_id());
  }
}

function cluevo_get_the_previous_lms_item() {
  global $wpdb, $cluevo;
  $table = $wpdb->prefix . CLUEVO_DB_TABLE_TREE;
  $sql = "SELECT item_id FROM $table WHERE parent_id = %d AND sort_order < %d ORDER BY sort_order DESC LIMIT 1";
  $result = $wpdb->get_var(
    $wpdb->prepare($sql, [ $cluevo->current_page->parent_id, $cluevo->current_page->sort_order ] )
  );

  if (!empty($result)) {
    return cluevo_get_learning_structure_item($result, get_current_user_id());
  }
}

function cluevo_get_the_lms_item_path() {
  global $cluevo;
  $item = null;
  if ($cluevo->in_the_dependency_loop)
    $item = $cluevo->dependency;
  else
    $item = $cluevo->item;

  return cluevo_get_string_path($item->path);

}

function cluevo_have_lms_dependencies() {
  global $cluevo;
  return $cluevo->have_dependencies();
}

function cluevo_the_lms_dependency() {
  global $cluevo;
  return $cluevo->the_dependency();
}

function cluevo_get_the_lms_item_metadata() {
  global $cluevo;
  return $cluevo->the_item_metadata();
}

function cluevo_load_lms_item($intId) {
  global $cluevo;
  $cluevo->load_item($intId);
}

function cluevo_load_lms_module($strModule) {
  global $cluevo;
  $cluevo->load_module($strModule);
}

function cluevo_create_lms_loop($items) {
  global $cluevo;
  $cluevo->init_loop($items);
}

function cluevo_get_the_module_progress($strModule) {
  global $cluevo;
  if (!empty($cluevo->user)) {
    $key = sanitize_key(SOURCENOVA_LMS_USER_SCORE_SCALED_META_KEY . $strModule);
    if (array_key_exists($key, $cluevo->user['meta']))
      return $cluevo->user['meta'][$key];
  }
  return 0;
}

function cluevo_get_the_lms_module() {
  global $cluevo;
  return $cluevo->module;
}

function cluevo_get_the_lms_users_competence_scores() {
  global $cluevo;
  if (!empty($cluevo->user)) {
    return $cluevo->user->competences;
  } else {
    return [];
  }
}

function cluevo_get_item_progress_value() {
  $progressValue = 0;
  $item = cluevo_get_the_lms_item();
  if (empty($item->module) || $item->module < 0) {
    $progressValue = (!empty($item->completed_children)) ? count($item->completed_children) : 0;
  } else {
    $user = cluevo_get_the_lms_user();
    if (!empty($user)) {
      $progressValue = cluevo_get_users_best_module_attempt($user->ID, $item->module_id);
    }
  }

  return $progressValue;
}

function cluevo_get_item_progress_max() {
  $progressMax = 0;
  $item = cluevo_get_the_lms_item();
  if (empty($item->module) || $item->module < 0) {
    $progressMax = count($item->children);
  } else {
    $user = cluevo_get_the_lms_user();
    if (!empty($user)) {
      $progressMax = 1;
    }
  }

  return $progressMax;
}

function cluevo_get_item_progress_width() {
  $progressMax = cluevo_get_item_progress_max();
  $progressValue = cluevo_get_item_progress_value();
  $progressWidth = 0;

  if ($progressMax > 0)
    $progressWidth = ($progressValue / $progressMax) * 100;

  return $progressWidth;
}

function cluevo_display_notice($strTitle, $strMessage, $strType = 'notice', $dismissible = false) { ?>
  <div class="cluevo-notice cluevo-notice-<?php echo esc_attr($strType); ?><?php echo ($dismissible) ? " is-dismissible" : ""; ?>">
    <p class="cluevo-notice-title"><?php echo esc_html($strTitle); ?></p>
    <p><?php echo esc_html($strMessage); ?></p>
  </div>
<?php }

function cluevo_display_notice_html($strTitle, $strMessage, $strType = 'notice', $dismissible = false) { ?>
  <div class="cluevo-notice cluevo-notice-<?php echo esc_attr($strType); ?><?php echo ($dismissible) ? " is-dismissible" : ""; ?>">
    <p class="cluevo-notice-title"><?php echo esc_html($strTitle); ?></p>
    <p><?php echo $strMessage; ?></p>
  </div>
<?php }

function cluevo_item_has_parent_item() {
  $parentPost = cluevo_get_the_parent_lms_page();
  return (!empty($parentPost));
}

function cluevo_user_has_item_access_level() {
  $item = cluevo_get_the_lms_page();
  if (!empty($item)) {
    return ($item->access_status["access_level"] == true);
  }
}

function cluevo_can_user_access_item() {
  $item = cluevo_get_the_lms_page();
  return $item->access;
}

function cluevo_get_the_items_module() {
  $item = cluevo_get_the_lms_page();
  $module = cluevo_get_module($item->module_id);
  return $module;
}

function cluevo_get_the_items_module_display_mode() {
  $item = cluevo_get_the_lms_item();
  if (!empty($item->display_mode)) {
    return $item->display_mode;
  } else {
    return strtolower(get_option("cluevo-modules-display-mode", "Lightbox"));
  }
}

function cluevo_get_the_content_list_style() {
  $cluevoListStyle = !empty($_COOKIE["cluevo-content-list-style"]) ? $_COOKIE["cluevo-content-list-style"] : null;
  $cluevoValidListStyles = ["cluevo-content-list-style-row", "cluevo-content-list-style-col"];
  $cluevoListStyle = (in_array($cluevoListStyle, $cluevoValidListStyles)) ? $cluevoListStyle : "cluevo-content-list-style-col";

  return $cluevoListStyle;
}

function cluevo_the_content_list_style() {
  echo cluevo_get_the_content_list_style();
}

function cluevo_get_the_breadcrumbs() {
  $item = cluevo_get_the_lms_page();
  if (empty($item)) return;
  global $cluevo;
  $userId = $cluevo->user_id;
  $i = 0;
  $parent = cluevo_get_learning_structure_item($item->parent_id, $userId, true);
  $crumbs = [$parent];
  if (!empty($parent) && !empty($parent->parent_id)) {
    do {
      $i++;
      $parent = cluevo_get_learning_structure_item($parent->parent_id, $userId, true);
      if (!empty($parent)) {
        $crumbs[] = $parent;
      }
    } while (!empty($parent) && $parent->parent_id > 0 && $i < 10);
  }
  $crumbs = array_reverse($crumbs);
  return $crumbs;
}

function cluevo_get_the_index_page() {
  if (($page = get_page_by_title( 'Index', OBJECT, CLUEVO_PAGE_POST_TYPE)) != NULL ) {
    return $page;
  }
  return false;
}

function cluevo_get_the_index_page_link() {
  $page = cluevo_get_the_index_page();
  if (!empty($page)) {
    $link = get_permalink($page);
    return $link;
  }
  return false;
}

function cluevo_get_the_shortcode_content() {
  global $cluevo;
  return $cluevo->shortcode_content;
}

function cluevo_user_has_competence_areas() {
  global $cluevo;
  if (empty($cluevo)) return false;
  if (empty($cluevo->user)) return false;
  return $cluevo->user->has_competence_areas();
}

function cluevo_the_users_competence_area() {
  global $cluevo;
  return $cluevo->user->the_competence_area();
}

function cluevo_get_the_users_competence_area() {
  global $cluevo;
  return $cluevo->user->competence_area;
}

function cluevo_get_the_users_competence_area_id() {
  global $cluevo;
  return $cluevo->user->competence_area->competence_area_id;
}

function cluevo_get_the_users_competence_area_name() {
  global $cluevo;
  return $cluevo->user->competence_area->competence_area_name;
}

function cluevo_get_the_users_competence_area_score() {
  global $cluevo;
  return $cluevo->user->competence_area->score;
}

function cluevo_get_the_users_competence_area_metadata_page() {
  global $cluevo;
  return get_post($cluevo->user->competence_area->metadata_id);
}

function cluevo_user_has_competences() {
  global $cluevo;
  if (empty($cluevo)) return false;
  if (empty($cluevo->user)) return false;
  return $cluevo->user->has_competences();
}

function cluevo_the_users_competence() {
  global $cluevo;
  return $cluevo->user->the_competence();
}

function cluevo_get_the_users_competence() {
  global $cluevo;
  return $cluevo->user->competence;
}

function cluevo_get_the_users_competence_name() {
  global $cluevo;
  return $cluevo->user->competence->competence_name;
}

function cluevo_get_the_users_competence_id() {
  global $cluevo;
  return $cluevo->user->competence->competence_id;
}

function cluevo_get_the_users_competence_score() {
  global $cluevo;
  return $cluevo->user->competence->score;
}

function cluevo_get_the_users_competences_metadata_page() {
  global $cluevo;
  return get_post($cluevo->user->competence->metadata_id);
}

function cluevo_users_competence_has_modules() {
  global $cluevo;
  if (empty($cluevo)) return false;
  if (empty($cluevo->user)) return false;
  return $cluevo->user->competence_has_modules();
}

function cluevo_the_users_competence_module() {
  global $cluevo;
  return $cluevo->user->the_competence_module();
}

function cluevo_get_the_users_competence_module() {
  global $cluevo;
  $score = $cluevo->user->competence_module->score;
  $module = cluevo_get_module($cluevo->user->competence_module->id);
  $module->competence_score = $score;
  return $module;
}

function cluevo_get_the_users_competence_module_score() {
  global $cluevo;
  return $cluevo->user->competence_module->score;
}

function cluevo_get_the_users_competence_module_coverage() {
  global $cluevo;
  return $cluevo->user->competence_module->coverage;
}


function cluevo_get_the_users_competence_module_id() {
  global $cluevo;
  return $cluevo->user->competence_module->id;
}

function cluevo_get_the_users_competence_module_metadata_page() {
  global $cluevo;
  $module = cluevo_get_module($cluevo->user->competence_module->id);
  return get_post($module->metadata_id);
}

function cluevo_get_the_lms_items_hide_info_box_setting() {
  global $cluevo;
  $item = (!empty($cluevo->item)) ? $cluevo->item : $cluevo->current_page;
  $item->load_settings();
  $value = $item->get_setting("hide-info-box");
  return ((int)$value === 1);
}

function cluevo_get_the_lms_items_empty_text() {
  global $cluevo;
  $item = (!empty($cluevo->item)) ? $cluevo->item : $cluevo->current_page;
  $item->load_settings();
  $text = trim($item->get_setting("element-is-empty-text"));
  return (!empty($text)) ? $text : __("This element is empty.", "cluevo");
}

function cluevo_the_lms_items_empty_text() {
  global $cluevo;
  $item = (!empty($cluevo->item)) ? $cluevo->item : $cluevo->current_page;
  $item->load_settings();
  $text = $item->get_setting("element-is-empty-text");
  echo (!empty($text)) ? esc_html($text) : __("This element is empty.", "cluevo");
}

function cluevo_get_the_lms_items_hide_access_denied_box_setting() {
  global $cluevo;
  $item = (!empty($cluevo->item)) ? $cluevo->item : $cluevo->current_page;
  $item->load_settings();
  $value = $item->get_setting("hide-access-denied-box");
  return ((int)$value === 1);
}

function cluevo_get_the_lms_items_access_denied_text() {
  global $cluevo;
  $text = __("You do not have the required permissions to access this element", "cluevo");
  if (!empty($cluevo->item)) {
    $item = (!empty($cluevo->item)) ? $cluevo->item : $cluevo->current_page;
    $item->load_settings();
    $text = trim($item->get_setting("access-denied-text"));
    $text = (!empty($text)) ? $text : __("You do not have the required permissions to access this element", "cluevo");
    if (!empty($item->settings["max-attempts"]) && (int)$item->settings["max-attempts"] > 0) {
      if (empty($item->access_status["attempts"])) {
        $text .= "\n";
        $text .= sprintf(__("You have already attempted this module the maximum amount of times: %d/%d", "cluevo"), $item->attempt_count, $item->settings["max-attempts"]);
      }
    }
  }
  return $text;
}

function cluevo_get_lms_item_access_denied_text($item) {
  $text = __("You do not have the required permissions to access this element", "cluevo");
  if (!empty($item)) {
    $item->load_settings();
    $text = trim($item->get_setting("access-denied-text"));
    $text = (!empty($text)) ? $text : __("You do not have the required permissions to access this element", "cluevo");
    if (!empty($item->settings["max-attempts"]) && (int)$item->settings["max-attempts"] > 0) {
      if (empty($item->access_status["attempts"])) {
        $text .= "\n";
        $text .= sprintf(__("You have already attempted this module the maximum amount of times: %d/%d", "cluevo"), $item->attempt_count, $item->settings["max-attempts"]);
      }
    }
  }
  return $text;
}

function cluevo_the_lms_items_access_denied_text() {
  global $cluevo;
  $item = (!empty($item)) ? $cluevo->item : $cluevo->current_page;
  $item->load_settings();
  $text = $item->get_setting("access-denied-text");
  echo (!empty($text)) ? esc_html($text) : __("You do not have the required permissions to access this element", "cluevo");
}

function cluevo_the_item_is_a_link() {
  global $cluevo;
  $item = (!empty($cluevo->item)) ? $cluevo->item : $cluevo->current_page;
  $item->load_settings();
  $link = trim($item->get_setting("item-is-link"));
  return ($link !== "") ? true : false;
}

function cluevo_the_items_link_opens_in_new_window() {
  global $cluevo;
  $item = (!empty($cluevo->item)) ? $cluevo->item : $cluevo->current_page;
  $item->load_settings();
  return ($item->get_setting("open-link-in-new-window") == 1) ? true : false;
}

function cluevo_get_the_items_link() {
  $meta = cluevo_the_lms_item_metadata();
  global $cluevo;
  $item = (!empty($cluevo->item)) ? $cluevo->item : $cluevo->current_page;
  $item->load_settings();
  $link = trim($item->get_setting("item-is-link"));
  if ($link !== "") return $link;
  if ($meta) return get_permalink($meta->ID);
}

function cluevo_turbo_get_users_completed_modules() {
  $uid = get_current_user_id();
  if (isset($GLOBALS["cluevo-users-completed-modules"])) {
    return $GLOBALS["cluevo-users-completed-modules"];
  } else {
    $GLOBALS["cluevo-users-completed-modules"] = cluevo_get_users_completed_modules($uid, false);
    return $GLOBALS["cluevo-users-completed-modules"];
  }
  return [];
}

function cluevo_build_module_dependencies() {
  global $wpdb;
  $depTable = $wpdb->prefix . CLUEVO_DB_TABLE_TREE_MODULE_DEPENDENCIES;
  $sql = "SELECT * FROM $depTable ORDER BY module_id";
  $rows = $wpdb->get_results($sql);
  $deps = [];
  $arrCompleted = (empty($arrCompleted)) ? cluevo_turbo_get_users_completed_modules() : [];
  if (!empty($rows)) {
    foreach ($rows as $row) {
      $id = $row->dep_id;
      $results = [ "normal" => [], "inherited" => [], "blocked" => [], "all" => [] ];
      if (array_key_exists($id, $deps)) {
        $results = $deps[$id];
      } else {
        $results = [ "normal" => [], "inherited" => [], "blocked" => [], "all" => [] ];
      }
      if (!array_key_exists($row->dep_type, $results))
        $results[$row->dep_type] = [];

      $results[$row->dep_type][$row->module_id] = false;
      if (!empty($row->module_id) && in_array($row->module_id, $arrCompleted)) $results[$row->dep_type][$row->module_id] = true;

      if (!empty($row->module_id) && ($row->dep_type == "normal" || $row->dep_type == "inherited")) {
        $results['all'][$row->module_id] = false;
        if (in_array($row->module_id, $arrCompleted)) $results["all"][$row->module_id] = true;
      }
      $deps[$id] = $results;
    }
  }
  $GLOBALS["cluevo-module-dependencies"] = $deps;
}

function cluevo_turbo_get_module_dependencies($intItemId = null, $arrCompleted = []) {
  if (isset($GLOBALS["cluevo-module-dependencies"]) && empty($intItemId)) {
    if (array_key_exists($intItemId, $GLOBALS["cluevo-module-dependencies"])) return $GLOBALS["cluevo-module-dependencies"][$intItemId];
    return [ "normal" => [], "inherited" => [], "blocked" => [], "all" => [] ];
    return $GLOBALS["cluevo-module-dependencies"];
  } else {
    if (!array_key_exists("cluevo-module-dependencies", $GLOBALS)) {
      cluevo_build_module_dependencies();
    }
    if (!empty($intItemId)) {
      if (array_key_exists($intItemId, $GLOBALS["cluevo-module-dependencies"])) return $GLOBALS["cluevo-module-dependencies"][$intItemId];
      return [ "normal" => [], "inherited" => [], "blocked" => [], "all" => [] ];
    } else {
      return $GLOBALS["cluevo-module-dependencies"];
    }
  }
  return [];
}

function cluevo_build_item_dependencies() {
  global $wpdb;
  $depTable = $wpdb->prefix . CLUEVO_DB_TABLE_TREE_DEPENDENCIES;
  $sql = "SELECT * FROM $depTable ORDER BY item_id";
  $rows = $wpdb->get_results($sql);
  $deps = [];
  if (!empty($rows)) {
    foreach ($rows as $row) {
      $id = $row->item_id;
      $results = [ "normal" => [], "inherited" => [], "blocked" => [], "all" => [] ];
      if (array_key_exists($id, $deps)) {
        $results = $deps[$id];
      } else {
        $results = [ "normal" => [], "inherited" => [], "blocked" => [], "all" => [] ];
      }
      if (!array_key_exists($row->dep_type, $results))
        $results[$row->dep_type] = [];

      $completed = false;
      if (!empty($row->dep_id)) {
        $dep = cluevo_turbo_get_tree_item($row->dep_id);
        if (!empty($dep) && $dep->completed) {
          $completed = true;
        }
      }
      $results[$row->dep_type][$row->dep_id] = $completed;

      if (!empty($row->dep_id) && ($row->dep_type == "normal" || $row->dep_type == "inherited")) {
        $results['all'][$row->dep_id] = $completed;
      }
      $deps[$id] = $results;
    }
  }
  $GLOBALS["cluevo-item-dependencies"] = $deps;
}

function cluevo_turbo_get_item_dependencies($intItemId = null) {
  if (isset($GLOBALS["cluevo-item-dependencies"]) && empty($intItemId)) {
    if (array_key_exists($intItemId, $GLOBALS["cluevo-item-dependencies"])) return $GLOBALS["cluevo-item-dependencies"][$intItemId];
    return [ "normal" => [], "inherited" => [], "blocked" => [], "all" => [] ];
  } else {
    if (isset($GLOBALS["cluevo-item-dependencies"]) && !empty($intItemId) && isset($GLOBALS["cluevo-item-dependencies"][$intItemId])) {
      return $GLOBALS["cluevo-item-dependencies"][$intItemId];
    } else {
      if (!array_key_exists("cluevo-item-dependencies", $GLOBALS)) {
        cluevo_build_item_dependencies();
      }
      return [ "normal" => [], "inherited" => [], "blocked" => [], "all" => [] ];
    }
    if (!empty($intItemId)) {
      if (array_key_exists($intItemId, $GLOBALS["cluevo-item-dependencies"])) return $GLOBALS["cluevo-item-dependencies"][$intItemId];
      return [ "normal" => [], "inherited" => [], "blocked" => [], "all" => [] ];
    } else {
      return $GLOBALS["cluevo-item-dependencies"];
    }
  }
  return [];
}

function cluevo_turbo_get_module($mixedId, $strLangCode = "", $boolRefresh = false) {
  $modules = cluevo_turbo_get_modules($strLangCode, $boolRefresh);
  $results = array_filter($modules, function($m) use($mixedId) {
    return ((is_numeric($mixedId) && $m->module_id == $mixedId) || $m->module_name == $mixedId);
  });
  if (!empty($results)) {
    return array_pop($results);
  }
  return null;
}

function cluevo_turbo_get_modules($strLangCode = "", $boolRefresh = false) {
  $last = (isset($GLOBALS["cluevo-last-module-lang"])) ? $GLOBALS["cluevo-last-module-lang"] : null;
  if (isset($GLOBALS["cluevo-modules"]) && $boolRefresh == false && $last == $strLangCode) {
    return $GLOBALS["cluevo-modules"];
  } else {
    $GLOBALS["cluevo-last-module-lang"] = $strLangCode;
    global $wpdb;
    $moduleTable = $wpdb->prefix . CLUEVO_DB_TABLE_MODULES;
    $moduleTypeTable = $wpdb->prefix . CLUEVO_DB_TABLE_MODULE_TYPES;
    $sql = "SELECT m.*, LOWER(t.type_name) AS type_name, t.type_description
      FROM $moduleTable m
      LEFT JOIN $moduleTypeTable t ON m.type_id = t.type_id";
    if (!empty($strLangCode)) {
      $sql .= " WHERE lang_code = %s";
      $results = $wpdb->get_results($wpdb->prepare($sql, [ $strLangCode ]), OBJECT);
    } else {
      $results = $wpdb->get_results($sql, OBJECT);
    }
    if (!empty($results)) {
      $GLOBALS["cluevo-modules"] = $results;
      return $GLOBALS["cluevo-modules"];
    } else {
      return [];
    }
  }
}

function cluevo_resolve_access($item) {
  $completedModules = cluevo_turbo_get_users_completed_modules();
  $perms = cluevo_turbo_get_users_permissions();
  $item->completed = false;
  $item->access_status = [ "dependencies" => true, "points" => true, "level" => true, "access_level" => false ];
  $item->parent_id = (empty($item->parent_id)) ? $item->tree_id : $item->parent_id;

  if (!empty($item->dependencies->other)) {
    foreach ($item->dependencies->other as $ok => $deps) {
      if (empty($item->dependencies->other->all)) $item->dependencies->other->all = new stdClass();
      foreach ($item->dependencies->other->{$ok} as $d => $state) {
        if ($ok == "all" || $ok == "blocked") continue;
        if (!empty($item->dependencies->other->all->{$id})) {
          $item->dependencies->other->all->{$d} = 0;
        }
      }
    }
  }

  if (!empty($item->dependencies->modules)) {
    foreach ($item->dependencies->modules as $mk => $deps) {
      if (empty($item->dependencies->modules->all)) $item->dependencies->modules->all = new stdClass();
      foreach ($item->dependencies->modules->{$mk} as $d => $state) {
        if ($mk == "all" || $mk == "blocked") continue;
        $fulfilled = 0;
        if (in_array($d, $completedModules)) {
          $fulfilled = 1;
        }
        if (!array_key_exists($d, $item->dependencies->modules->all)) {
          $item->dependencies->modules->all->{$d} = $fulfilled;
        }
        $item->dependencies->modules->{$mk}->{$d} = $fulfilled;
      }
    }
  }

  $granted = true;
  $access = true;
  if (!empty($item->dependencies->other->all)) {
    foreach ($item->dependencies->other->all as $dep => $value) {
      if ($value == false) {
        $granted = false;
        $access = false;
        break;
      }
    }
  }

  if ($granted && !empty($item->dependencies->modules->all)) {
    foreach ($item->dependencies->modules->all as $dep => $value) {
      if (!in_array($dep, $completedModules)) {
        $granted = false;
        $access = false;
        break;
      }
    }
  }
  $item->dependencies = json_decode(json_encode($item->dependencies), true);
  $item->access_status["dependencies"] = $granted;

  $access_level = 0;
  if (current_user_can('administrator')) {
    $access_level = 999;
  } else {
    if (array_key_exists($item->item_id, $perms)) {
      $access_level = $perms[$item->item_id];
    }
  }

  $item->access_level = $access_level;
  $item->access_status["access_level"] = $access_level;


  $access = true;
  foreach ($item->access_status as $type => $value) {
    if ($value == false || ($type == "access_level" && $value < 2)) {
      $access = false;
    }
  }

  $item->access = ($access || current_user_can("administrator"));

  if (!empty($item->module_id) && $item->module_id > 0) {
    $item->module = $item->module_id;
    if (in_array($item->module, $completedModules)) {
      $item->completed = true;
    }
  }
  return $item;
}

function cluevo_turbo_get_trees() {
  //$uid = get_current_user_id();
  $perms = cluevo_turbo_get_users_permissions();

  if (isset($GLOBALS["cluevo-trees"])) {
    return $GLOBALS["cluevo-trees"];
  } else {
    $trees = [];
    $structs = cluevo_turbo_get_tree_structs();
    if (!empty($structs)) {
      foreach ($structs as $s) {
        if (current_user_can("administrator") || array_key_exists($s->item_id, $perms) && $perms[$s->item_id] > 0) {
          $trees[$s->item_id] = $s;
        }
      }
    }

    $completedModules = cluevo_turbo_get_users_completed_modules();
    foreach ($trees as $id => $tree) {
      if (!empty($tree)) {

        $tree = cluevo_resolve_access($tree);
        foreach ($tree->children as $i => $item) {
          $item->children = [];
          $item->completed_children = [];
          $item = cluevo_resolve_access($item);
          $item = CluevoItem::from_std_class($item);
          $item = apply_filters("cluevo_check_item_access", $item);
          $tree->children[$i] = $item;
        }

        usort($tree->children, function($a, $b) {
          if (isset($a->sort_order) && isset($b->sort_order)) {
            if($a->sort_order == $b->sort_order) return 0;
            return ($a->sort_order < $b->sort_order) ? - 1 : 1;
          }
          return 1;
        });

        foreach ($tree->children as $item) {
          $item->children = cluevo_turbo_build_hierarchy($tree->children, $item->item_id);
          $item->completed_children = [];
          foreach ($item->children as $child) {
            if (empty($child->access_level) || $child->access_level < 1) continue;
            if ($child->completed)
              $item->completed_children[] = $child->item_id;
          }

          if (empty($item->module) || $item->module < 1) {
            $item->completed = false;
            if (!empty($item->children)) {
              $item->completed = (count($item->children) == count($item->completed_children));
            }
          }
        }
      }
    }

    $GLOBALS["cluevo-trees"] = $trees;
    foreach ($trees as $tKey => $tree) {
      $completed = [];
      foreach ($tree->children as $key => $item) {
        $access = 1;
        if (!empty($item->dependencies["other"]["all"])) {
          foreach ($item->dependencies["other"]["all"] as $dk => $state) {
            $dep = cluevo_turbo_get_tree_item($dk);
            if ($dep->completed) {
              $tree->children[$key]->dependencies["other"]["all"][$dk] = 1;
            } else {
              $access = 0;
            }
          }
        }
        if ($access) {
          foreach ($item->dependencies["modules"]["all"] as $dk => $state) {
            if (in_array($dk, $completedModules)) {
              $tree->children[$key]->dependencies["modules"]["all"][$dk] = 1;
            } else {
              $access = 0;
            }
          }
        }
        if (!empty($tree->children)) {
          $tree->children[$key]->access_status["dependencies"] = $access;
          if (!empty($tree->children[$key]->access_status["dependencies"])) {
            $childAccess = 1;
            foreach ($tree->children[$key]->access_status as $status) {
              if (empty($status)) {
                $childAccess = 0;
                break;
              }
            }
            $access = ($access && $childAccess);
            $tree->children[$key]->access = (current_user_can("administrator") || ($access && $item->access_level > 1)) ? 1 : 0;
          }
        }
        if ($item->parent_id == $tree->item_id && $item->completed) $completed[] = $item->item_id;
      }
      $trees[$tKey]->completed_children = $completed;
    }
    $GLOBALS["cluevo-trees"] = $trees;
    //update_option("cluevo-turbo-trees-$uid", $trees);
    return $GLOBALS["cluevo-trees"];
  }
  return [];
}

function cluevo_turbo_get_trees_index() {
  $trees = cluevo_turbo_get_trees();
  if (!empty($trees)) {
    foreach ($trees as $key => $tree) {
      $trees[$key]->children = array_filter($tree->children, function($c) use ($tree) {
        return $c->access_status["access_level"] > 0 && $c->parent_id == $tree->item_id;
      });
    }
  }
  return $trees;
}

function cluevo_turbo_build_hierarchy($source, $intParentId) {
  $children = [];
  $perms = cluevo_turbo_get_users_permissions();
  foreach ($source as $item) {
    if (!current_user_can("administrator") && !array_key_exists($item->item_id, $perms)) continue;
    if (!current_user_can("administrator") && $perms[$item->item_id] < 1) continue;
    

    if ($item->parent_id == $intParentId) {
      $itemChildren = cluevo_turbo_build_hierarchy($source, $item->item_id);
      $item->children = [];
      $item->completed_children = [];
      foreach ($itemChildren as $child) {
        if (array_key_exists($child->item_id, $perms) && $perms[$child->item_id] > 0 || current_user_can("administrator")) {
          $item->children[] = $child;
          if ($child->completed)
            $item->completed_children[] = $child->item_id;
        }
      }

      if (empty($item->module) || $item->module < 1) {
        $item->completed = false;
        if (!empty($item->children)) {
          $item->completed = (count($item->children) == count($item->completed_children));
        }
      }
      $children[] = $item;
    }
  }
  usort($children, function($a, $b) {
    if (isset($a->sort_order) && isset($b->sort_order)) {
      if($a->sort_order == $b->sort_order) return 0;
      return ($a->sort_order < $b->sort_order) ? - 1 : 1;
    }
    return 1;
  });
  return $children;
}

function cluevo_turbo_get_users_permissions() {
  $uid = get_current_user_id();

  if (isset($GLOBALS["cluevo-users-permissions"]) && is_array($GLOBALS["cluevo-users-permissions"])) {
    return $GLOBALS["cluevo-users-permissions"];
  } else {
    global $wpdb;
    $permTable = $wpdb->prefix . CLUEVO_DB_TABLE_TREE_PERMS;
    $groupTable = $wpdb->prefix . CLUEVO_DB_TABLE_USERS_TO_GROUPS;

    $args = [];
    if (!empty($uid)) {
      $sql = "SELECT item_id, MAX(access_level) AS access_level FROM
        {$permTable} tp
        WHERE perm = CONCAT('u:', %d) OR perm IN (
          SELECT perm
          FROM {$permTable} tp
          INNER JOIN {$groupTable} utg ON utg.user_id = %d AND CONCAT('g:', utg.group_id) = tp.perm
        )
        GROUP BY item_id";
      $args = [ $uid, $uid ];
    } else {
      $sql = "SELECT item_id, MAX(access_level) AS access_level FROM
        {$permTable} tp WHERE perm = CONCAT('g:', %d)
        GROUP BY item_id";
      $args = [ CLUEVO_DEFAULT_GROUP_GUEST ];
    }

    $results = $wpdb->get_results(
      $wpdb->prepare($sql, $args)
    );

    $perms = [];
    if (!empty($results)) {
      foreach ($results as $row) {
        $perms[$row->item_id] = (int)$row->access_level;
      }
    }
    $GLOBALS["cluevo-users-permissions"] = $perms;
    return $GLOBALS["cluevo-users-permissions"];
  }
  return [];
}

function cluevo_turbo_get_item_children($intItemId) {
  return cluevo_turbo_get_tree_item($intItemId, true);
}

function cluevo_turbo_get_tree_structs() {
  $perms = cluevo_turbo_get_users_permissions();
  if (isset($GLOBALS["cluevo-tree-structs"]) && is_array($GLOBALS["cluevo-tree-structs"])) {
    return $GLOBALS["cluevo-tree-structs"];
  } else {
    //$trees = cluevo_get_learning_structures(null, true);
    global $wpdb;
    $treeTable = $wpdb->prefix . CLUEVO_DB_TABLE_TREE;
    $opts = $wpdb->get_results(
      "SELECT option_name, option_value, t.* FROM {$wpdb->prefix}options o
      INNER JOIN $treeTable t ON t.item_id = replace(o.option_name, 'cluevo-lms-tree-', '')
      WHERE option_name LIKE 'cluevo-lms-tree-%'");
    if (empty($opts)) return [];
    $trees = [];
    foreach ($opts as $opt) {
      $id = str_replace("cluevo-lms-tree-", "", $opt->option_name);
      $t = CluevoItem::from_std_class($opt);
      $t->metadata_id = $opt->metadata_id;
      $t->item_id = $id;
      $children = json_decode($opt->option_value);
      if (!empty($children)) {
        foreach ($children as $c) {
          $t->children[] = $c;
        }
      }
      $t->completed_children = [];
      $modules = [];
      if (!empty($children)) {
        foreach ($children as $c) {
          if (!empty($c->modules)) {
            foreach ($c->modules as $m) {
              if (!empty($m) && $m > 0 && !in_array($m, $modules)) $modules[] = $m;
            }
          }
        }
      }
      $level = 0;
      if (array_key_exists($t->item_id, $perms)) {
        $level = $perms[$t->item_id];
      }
      if (current_user_can("administrator")) {
        $level = 999;
      }
      $t->access_status["access_level"] = $level;
      $t->access_level = $level;
      $t->modules = $modules;
      $t->completed = false;
      $trees[] = $t;
    }
    $GLOBALS["cluevo-tree-structs"] = $trees;
    return $GLOBALS["cluevo-tree-structs"];
  }
}

function cluevo_turbo_get_tree_item($intItemId, $boolChildren = false) {
  $trees = cluevo_turbo_get_trees();
  $perms = cluevo_turbo_get_users_permissions();
  $item = null;
  if (empty($intItemId)) {
    $items = [];
    foreach ($trees as $tree) {
      $t = $tree;
      $t->children = array_filter($t->children, function($c) use($t) {
        return $c->parent_id == $t->item_id;
      });
      $items[] = $t;
    }
    return $items;
  } else {
    foreach ($trees as $tid => $tree) {
      if ($tid == $intItemId) {
        $cloneTree = clone $tree; // this is needed so the original tree is not modified due to some php weirdness
        $cloneTree->children = array_filter($cloneTree->children, function($arr) use ($intItemId, $perms) {
          if (!current_user_can("administrator") && (!array_key_exists($arr->item_id, $perms) || $perms[$arr->item_id] < 1)) return false;
          return $arr->parent_id == $intItemId;
        });
        $cloneTree->children = array_values($cloneTree->children);
        if (is_string($tree->modules)) {
          $cloneTree->modules = explode(",", $cloneTree->modules);
        }
        if ($boolChildren) {
          return $cloneTree->children;
        } else {
          return $cloneTree;
        }
      } else {
        $items = cluevo_turbo_find_item($tree->children, $intItemId);
        if (!empty($items)) {
          $item = array_pop($items);
          break;
        }
      }
    }
  }
  if (!$boolChildren) {
    return $item;
  } else {
    if (!empty($item) && !empty($item->children)) {
      return $item->children;
    } else {
      return [];
    }
  }
}

function cluevo_turbo_find_item($items, $intItemId) {

  $results = array_filter($items, function($item) use ($intItemId) {
    return $item->item_id == $intItemId;
  });

  if (empty($results)) {
    foreach ($items as $item) {
      $results = cluevo_turbo_find_item($item->children, $intItemId);
      if (!empty($results)) break;
    }
  }
  return $results;
}

function cluevo_turbo_get_tree($intItemId) {
  $trees = cluevo_turbo_get_trees();
  if (array_key_exists($intItemId, $trees)) {
    $tree = $trees[$intItemId];
    $tree->children = array_filter($tree->children, function($c) use ($intItemId) {
      return $c->parent_id == $intItemId;
    });
    return $tree;
  }
  return null;
}

function cluevo_turbo_get_item_id_by_meta_id($intItemId) {
  $trees = cluevo_turbo_get_trees();
  foreach ($trees as $tid => $tree) {
    if ($tree->metadata_id == $intItemId) {
      return $tree->item_id;
    }
    $items = array_filter($tree->children, function($c) use ($intItemId) {
      return $c->metadata_id == $intItemId;
    });
    if (!empty($items)) {
      $item = array_pop($items);
      return $item->item_id;
    }
  }
  return null;
}

function cluevo_turbo_get_meta_id_from_item_id($intItemId) {
  $item = cluevo_turbo_get_tree_item($intItemId);
  if (!empty($item)) return $item->metadata_id;
  return null;
}

function cluevo_clear_module_cache() {
  if (isset($GLOBALS["cluevo-modules"])) {
    unset($GLOBALS["cluevo-modules"]);
  }
}

function cluevo_clear_turbo_cache() {
  if (isset($GLOBALS["cluevo-users-completed-modules"])) {
    unset($GLOBALS["cluevo-users-completed-modules"]);
  }
  if (isset($GLOBALS["cluevo-modules"])) {
    unset($GLOBALS["cluevo-modules"]);
  }
  if (isset($GLOBALS["cluevo-trees"])) {
    unset($GLOBALS["cluevo-trees"]);
  }
  if (isset($GLOBALS["cluevo-tree-structs"])) {
    unset($GLOBALS["cluevo-tree-structs"]);
  }
}

function cluevo_clear_groups_cache() {
  if (isset($GLOBALS["cluevo_groups"])) {
    unset($GLOBALS["cluevo_groups"]);
  }
}

function cluevo_turbo_get_groups($mixedGroups = null) {
  $last = (isset($GLOBALS["cluevo-last-groups"])) ? $GLOBALS["cluevo-last-groups"] : -1;
  if (isset($GLOBALS["cluevo_groups"]) && is_array($GLOBALS["cluevo_groups"]) && $last == $mixedGroups) {
    return $GLOBALS["cluevo_groups"];
  } else {
    $GLOBALS["cluevo_groups"] = cluevo_get_user_groups($mixedGroups);
    $GLOBALS["cluevo-last-groups"] = $mixedGroups;
    return $GLOBALS["cluevo_groups"];
  }
}

?>
